Attribute VB_Name = "mConfiguration"
' ==========================================================================================
' Code source par Nicolas Siwik aka Ennixo
' ==========================================================================================
' http://www.ennixo.com
' http://ennixo.free.fr/fils
' ennixo@free.fr
' ==========================================================================================

Private Const FICHIERCONF           As String = "Fils.conf"
Private Const FICHIERPARAMS         As String = "Params.conf"

Public Type ConfigVar
    Nom             As String
    Valeur          As String
End Type

Declare Function PathCompactPathEx Lib "shlwapi.dll" Alias "PathCompactPathExA" (ByVal pszOut As String, ByVal pszSrc As String, ByVal cchMax As Long, ByVal dwFlags As Long) As Long

Public Config() As ConfigVar
Public Params() As ConfigVar

' calcule la taille d'un fichier  afficher
Public Function oKoMoGoTo(ByVal Taille As Long) As String

    If Taille <= 1 Then
        oKoMoGoTo = CStr(Taille) & " octet"
    ElseIf Taille < 1024 Then
        oKoMoGoTo = CStr(Taille) & " octets"
    ElseIf Taille <= 1048576 Then
        oKoMoGoTo = Replace(CStr(Int((Taille / 1024) * 100) / 100), ".", ",") & " Ko"
    ElseIf Taille <= 1073741824 Then
        oKoMoGoTo = Replace(CStr(Int((Taille / 1048576) * 100) / 100), ".", ",") & " Mo"
    ElseIf CDbl(Taille) <= 1099511627776# Then
        oKoMoGoTo = Replace(CStr(Int((Taille / 1073741824) * 100) / 100), ".", ",") & " Go"
    Else
        oKoMoGoTo = "1 To+"
    End If

End Function

' vrifie l'existance d'un fichier
Public Function FichExiste(ByVal Fichier As String) As Boolean

    On Error GoTo existepas
    
    l& = FileLen(Fichier)
    FichExiste = True
    Exit Function
    
existepas:

    FichExiste = False

End Function

' Retourne l'extension d'un fichier
Public Function GetExt(ByVal Fichier As String) As String

    Dim a       As Long
    
    a = InStr(1, StrReverse(Fichier), ".") - 1

    If a > 0 Then GetExt = LCase$(Right$(Fichier, a))

End Function

' ajoute un \  la fin d'un dossier si ncessaire
Public Function EndSlash(ByVal Dossier As String) As String

    EndSlash = Dossier
    If Right$(Dossier, 1) <> "\" Then EndSlash = EndSlash & "\"

End Function

' trouve un nom de fichier temporaire libre
Public Function getTempName(ByVal Dossier As String, ByVal Extension As String) As String

    Const chars As String = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-+~"

    Dim i       As Long
    
    Randomize

    Do
        getTempName = "FilsTemp_"
        For i = 1 To 20
            getTempName = getTempName & Mid$(chars, Int(Rnd * (Len(chars) - 1) + 1), 1)
        Next i
        getTempName = EndSlash(Dossier) & getTempName & "." & Extension
        
    Loop While FichExiste(getTempName)

End Function

' rcupre le nom de dossier uniquement
Public Function getDossier(ByVal Fichier As String) As String

    Dim a       As Long
    
    a = Len(Fichier) - InStr(1, StrReverse(Fichier), "\")

    If a > 1 Then getDossier = Left$(Fichier, a)

End Function

' rcupre le nom de fichier uniquement
Public Function getFichier(ByVal Fichier As String) As String

    Dim a       As Long
    
    a = InStr(1, StrReverse(Fichier), "\") - 1

    If a > 0 Then getFichier = Right$(Fichier, a)

End Function

' Compacte le nom pour 40 caractres
Public Function compacteFichier(ByVal Fichier As String) As String

    Dim sSave As String * 40

    PathCompactPathEx sSave, Fichier, 40, 0

    compacteFichier = sSave
    
End Function

' Charge un fichier de configuration dans un tableau
Public Sub LoadFileToArray(ByVal FileName As String, ByRef Arr() As ConfigVar)

    Dim Fi          As Integer: Fi = FreeFile()
    Dim Li          As String
    Dim tLi()       As String
    
    ReDim Arr(0)
    
    Open FileName For Input As #Fi
    
    Do Until EOF(Fi)
        Line Input #Fi, Li
        If Trim$(Li) <> "" Then
            tLi = Split(Li, "=", 2)
            If UBound(tLi) = 1 Then
                ReDim Preserve Arr(UBound(Arr) + 1)
                With Arr(UBound(Arr))
                    .Nom = Trim$(tLi(0))
                    .Valeur = Trim$(tLi(1))
                    If Left$(.Valeur, 1) = """" Then .Valeur = Right$(.Valeur, Len(.Valeur) - 1)
                    If Right$(.Valeur, 1) = """" Then .Valeur = Left$(.Valeur, Len(.Valeur) - 1)
                End With
            ElseIf Left$(LTrim$(Li), 1) = "#" Then
                ReDim Preserve Arr(UBound(Arr) + 1)
                With Arr(UBound(Arr))
                    .Nom = "#" 'Commentaire
                    .Valeur = Li
                End With
            Else
                'ligne erreur non prise en compte
            End If
        Else
            ReDim Preserve Arr(UBound(Arr) + 1)
            With Arr(UBound(Arr))
                .Nom = "CRLF" 'Saut de ligne
                .Valeur = ""
            End With
        End If
    Loop
    
    Close #Fi


End Sub

' Enregistre un tableau dans un fichier de configuration
Public Sub SaveArrayToFile(ByRef Arr() As ConfigVar, ByVal FileName As String)

    Dim Fi          As Integer: Fi = FreeFile()
    
    Open FileName For Output As #Fi
    
    For i = 1 To UBound(Arr)
        If Arr(i).Nom = "#" Then 'Commentaire
            Print #Fi, Arr(i).Valeur
        ElseIf Arr(i).Nom = "CRLF" Then 'saut de ligne
            Print #Fi, ""
        ElseIf Arr(i).Nom <> "" Then
            If IsNumeric(Arr(i).Valeur) Then
                Print #Fi, Arr(i).Nom & " = " & Arr(i).Valeur
            Else
                Print #Fi, Arr(i).Nom & " = """ & Arr(i).Valeur & """"
            End If
        End If
    Next i
    
    Close #Fi

End Sub

' Charge la configuration, ne gre pas les erreurs
Public Sub LoadConfig()

    Dim Path    As String: Path = EndSlash(App.Path)
    Dim Fich    As String
    
    Fich = Path & FICHIERCONF
    If FichExiste(Fich) Then
        LoadFileToArray Fich, Config
    Else
        MsgBox "Impossible de trouver le fichier de configuration ! Il se peut que que Ennixo Fils ne fonctionne pas correctement !", vbCritical + vbOKOnly
    End If
    If FichExiste(Fich) Then
        LoadFileToArray Path & FICHIERPARAMS, Params
    Else
        ReDim Params(0)
    End If
    
End Sub

' Enregistre la configuration
Public Sub SaveConfig()

    SaveArrayToFile Config, EndSlash(App.Path) & FICHIERCONF
    SaveArrayToFile Params, EndSlash(App.Path) & FICHIERPARAMS
    
End Sub

' rcupre une valeur de configuration, ne gre pas les erreurs
Public Function GetConfigValue(ByVal Nom As String) As String

    Dim i   As Long

    For i = 1 To UBound(Config)
        If Config(i).Nom = Nom Then
            GetConfigValue = Config(i).Valeur
            Exit Function
        End If
    Next i

End Function

' dfinit une valeur de configuration
Public Sub SetConfigValue(ByVal Nom As String, ByVal Valeur As String)

    Dim i   As Long

    For i = 1 To UBound(Config)
        If Config(i).Nom = Nom Then
            Config(i).Valeur = Valeur
            Exit Sub
        End If
    Next i
    
    i = UBound(Config) + 1
    ReDim Preserve Config(i)
    Config(i).Nom = Nom
    Config(i).Valeur = Valeur
    
End Sub

' ajoute un fichier rcent
Public Sub AddRecent(ByVal FileName As String)

    For i = 1 To 10
        If GetConfigValue("Recent" & CStr(i)) = FileName Then
            If i = 1 Then Exit Sub 'il y est dj on ne touche  rien !
            For j = i - 1 To 1 Step -1
                SetConfigValue "Recent" & CStr(j + 1), GetConfigValue("Recent" & CStr(j))
            Next j
            GoTo PROC_UPDATEMENU
        End If
    Next i
    
    ' dcale tout d'un cran jusq'au dbut
    For i = 9 To 1 Step -1
        SetConfigValue "Recent" & CStr(i + 1), GetConfigValue("Recent" & CStr(i))
    Next i
    
PROC_UPDATEMENU:

    'place le fichier tout au dbut
    SetConfigValue "Recent1", FileName

    'actualise le menu
    frmMain.UpdateRecentMenu

End Sub
