Attribute VB_Name = "mDessin"
' ==========================================================================================
' Code source par Nicolas Siwik aka Ennixo
' ==========================================================================================
' http://www.ennixo.com
' http://ennixo.free.fr/fils
' ennixo@free.fr
' ==========================================================================================

Public Const PI         As Single = 3.1415926
Public Const PI2        As Single = 6.2831853
Public Const PIs2       As Single = 1.5707963
Public Const PIs4       As Single = 0.7853982

Public Const SW_SHOWNORMAL As Long = 1&

Public Enum OverrideSlider
    NoOverride
    CanBeEqual
    MaxCanBeLess
End Enum

Public Enum StatusIcon
    NoChange = -1
    NoIcon
    ReadyIcon
    WorkingIcon
    AttentionIcon
End Enum

Public Type BITMAP
    bmType              As Long
    bmWidth             As Long
    bmHeight            As Long
    bmWidthBytes        As Long
    bmPlanes            As Integer
    bmBitsPixel         As Integer
    bmBits              As Long
End Type

Public Type UndoList
    Bits()              As Byte
    Titre               As String
    Hash                As Long
End Type

Public Declare Function GetObject Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Public Declare Function GetBitmapBits Lib "gdi32" (ByVal hBitmap As Long, ByVal dwCount As Long, lpBits As Any) As Long
Public Declare Function SetBitmapBits Lib "gdi32" (ByVal hBitmap As Long, ByVal dwCount As Long, lpBits As Any) As Long
Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Public PicInfo          As BITMAP
Public PicBits()        As Byte
Public PicHash          As Long
Public NewHash          As Long
Public NewBits()        As Byte
Public Matrix()         As Long
Public Pourcentage      As Long

Public Undo()           As UndoList
Public CurrentUndo      As Long

' Ngativise la couleur (ngatif mais prend en compte le gris
Public Function NegColor(ByVal Color As Long) As Long

    Dim r               As Byte
    Dim g               As Byte
    Dim b               As Byte
    Dim nr              As Byte
    Dim ng              As Byte
    Dim nb              As Byte
    Dim t               As Long
    Dim nT              As Long

    r = CByte(Color Mod 256)
    g = CByte((Color \ &H100) Mod 256)
    b = CByte((Color \ &H10000) Mod 256)
    
    nr = Not r
    ng = Not g
    nb = Not b
    
    t = CLng(r) + CLng(g) + CLng(b)
    nT = CLng(nr) + CLng(ng) + CLng(nb)
    
    If Abs(CLng(r) - CLng(nr)) < 50 And Abs(CLng(g) - CLng(ng)) < 50 And Abs(CLng(b) - CLng(nb)) < 50 Then
        If nT <= t Then
            nr = 0
            ng = 0
            nb = 0
        Else
            nr = 255
            ng = 255
            nb = 255
        End If
    End If
    
    
    NegColor = RGB(nr, ng, nb)

End Function

' Converti une couleur de type Long en couleur de type Web
Public Function Long2Web(ByVal Color As Long) As String
    
    Dim r               As String
    Dim g               As String
    Dim b               As String

    r = Hex$(Color Mod 256)
    g = Hex$((Color \ &H100) Mod 256)
    b = Hex$((Color \ &H10000) Mod 256)
    
    If Len(r) = 1 Then r = "0" & r
    If Len(g) = 1 Then g = "0" & g
    If Len(b) = 1 Then b = "0" & b
    
    Long2Web = r & g & b

End Function

' Converti une couleur de type Web en couleur de type Long
Public Function Web2Long(ByVal Web As String) As Long

    Dim r               As Integer
    Dim g               As Integer
    Dim b               As Integer

    If Len(Web) < 4 Then
        Web2Long = &HFFFFFFFF
    Else
        r = Val("&H" & Left$(Web, 2))
        g = Val("&H" & Mid$(Web, 3, 2))
        b = Val("&H" & Right$(Web, 2))
        Web2Long = RGB(r, g, b)
    End If

End Function

' Calcule un Hash pour l'image (pour le hasard...)
Public Function NSHash() As Long

    Dim i   As Long

    NSHash = 0

    For i = 1 To UBound(PicBits) Step 4
    
        NSHash = NSHash + (CLng(PicBits(i)) + CLng(PicBits(i + 1)) + CLng(PicBits(i + 2)))
        
        If NSHash > 2000000000 Then NSHash = NSHash \ 2
        
    Next i
    
    NSHash = NSHash And &H7FFFFFFF
    
End Function

' Cre une matrice
Public Function BuildMatrix() As Long()

    Dim X               As Long
    Dim Y               As Long
    Dim PicMatrix()     As Long
    Dim i               As Long

    ReDim PicMatrix(1 To PicInfo.bmWidth, 1 To PicInfo.bmHeight)
    
    X = 1
    Y = 1
    
    For i = 1 To UBound(PicBits) Step 4
        PicMatrix(X, Y) = i
        X = X + 1
        If X > PicInfo.bmWidth Then
            X = 1
            Y = Y + 1
        End If
        If Y > PicInfo.bmHeight Then Exit For
    Next i
    
    BuildMatrix = PicMatrix

End Function

' Trace un pixel avec anticrnelage (WU)
Public Sub SetPixelAA( _
    ByVal XX As Single, _
    ByVal YY As Single, _
    ByVal r As Byte, _
    ByVal g As Byte, _
    ByVal b As Byte)
    
    If Not frmLignes.chkCrenelage.Checked Then
    
        Dim Xi              As Long: Xi = CLng(XX)
        Dim Yi              As Long: Yi = CLng(YY)
        
        Dim xP              As Single
        Dim yP              As Single
        
        Dim pA              As Single
        Dim pB              As Single
        Dim pC              As Single
        Dim pD              As Single
        
        If Xi > XX Then Xi = Xi - 1
        If Yi > YY Then Yi = Yi - 1
        
        If Xi > 0 And Yi > 0 And Xi < PicInfo.bmWidth And Yi < PicInfo.bmHeight Then
        
            ' A cheval sur 4 pixels
            If Xi <> XX And Yi <> YY Then
            
                xP = XX - Xi
                yP = YY - Yi
            
                pA = (1 - xP) * (1 - yP)
                pB = xP * (1 - yP)
                pC = (1 - xP) * yP
                pD = xP * yP
                
                NewBits(Matrix(Xi, Yi) + 2) = r * pA + NewBits(Matrix(Xi, Yi) + 2) * (1 - pA)
                NewBits(Matrix(Xi, Yi) + 1) = g * pA + NewBits(Matrix(Xi, Yi) + 1) * (1 - pA)
                NewBits(Matrix(Xi, Yi)) = b * pA + NewBits(Matrix(Xi, Yi)) * (1 - pA)
        
                NewBits(Matrix(Xi + 1, Yi) + 2) = r * pB + NewBits(Matrix(Xi + 1, Yi) + 2) * (1 - pB)
                NewBits(Matrix(Xi + 1, Yi) + 1) = g * pB + NewBits(Matrix(Xi + 1, Yi) + 1) * (1 - pB)
                NewBits(Matrix(Xi + 1, Yi)) = b * pB + NewBits(Matrix(Xi + 1, Yi)) * (1 - pB)
            
                NewBits(Matrix(Xi, Yi + 1) + 2) = r * pC + NewBits(Matrix(Xi, Yi + 1) + 2) * (1 - pC)
                NewBits(Matrix(Xi, Yi + 1) + 1) = g * pC + NewBits(Matrix(Xi, Yi + 1) + 1) * (1 - pC)
                NewBits(Matrix(Xi, Yi + 1)) = b * pC + NewBits(Matrix(Xi, Yi + 1)) * (1 - pC)
        
                NewBits(Matrix(Xi + 1, Yi + 1) + 2) = r * pD + NewBits(Matrix(Xi + 1, Yi + 1) + 2) * (1 - pD)
                NewBits(Matrix(Xi + 1, Yi + 1) + 1) = g * pD + NewBits(Matrix(Xi + 1, Yi + 1) + 1) * (1 - pD)
                NewBits(Matrix(Xi + 1, Yi + 1)) = b * pD + NewBits(Matrix(Xi + 1, Yi + 1)) * (1 - pD)
            
            ' A cheval sur 2 pixels  l'horizontale
            ElseIf Xi <> XX Then
        
                pA = 1 - (XX - Xi)
                pB = XX - Xi
        
                NewBits(Matrix(Xi, Yi) + 2) = r * pA + NewBits(Matrix(Xi, Yi) + 2) * (1 - pA)
                NewBits(Matrix(Xi, Yi) + 1) = g * pA + NewBits(Matrix(Xi, Yi) + 1) * (1 - pA)
                NewBits(Matrix(Xi, Yi)) = b * pA + NewBits(Matrix(Xi, Yi)) * (1 - pA)
                
                NewBits(Matrix(Xi + 1, Yi) + 2) = r * pB + NewBits(Matrix(Xi + 1, Yi) + 2) * (1 - pB)
                NewBits(Matrix(Xi + 1, Yi) + 1) = g * pB + NewBits(Matrix(Xi + 1, Yi) + 1) * (1 - pB)
                NewBits(Matrix(Xi + 1, Yi)) = b * pB + NewBits(Matrix(Xi + 1, Yi)) * (1 - pB)
        
            ' A cheval sur 2 pixels  la verticale
            ElseIf Yi <> YY Then
            
                pA = 1 - (YY - Yi)
                pC = YY - Yi
        
                NewBits(Matrix(Xi, Yi) + 2) = r * pA + NewBits(Matrix(Xi, Yi) + 2) * (1 - pA)
                NewBits(Matrix(Xi, Yi) + 1) = g * pA + NewBits(Matrix(Xi, Yi) + 1) * (1 - pA)
                NewBits(Matrix(Xi, Yi)) = b * pA + NewBits(Matrix(Xi, Yi)) * (1 - pA)
                
                NewBits(Matrix(Xi, Yi + 1) + 2) = r * pC + NewBits(Matrix(Xi, Yi + 1) + 2) * (1 - pC)
                NewBits(Matrix(Xi, Yi + 1) + 1) = g * pC + NewBits(Matrix(Xi, Yi + 1) + 1) * (1 - pC)
                NewBits(Matrix(Xi, Yi + 1)) = b * pC + NewBits(Matrix(Xi, Yi + 1)) * (1 - pC)
            
            ' pile poil sur 1 pixel
            Else
                
                NewBits(Matrix(Xi, Yi) + 2) = r
                NewBits(Matrix(Xi, Yi) + 1) = g
                NewBits(Matrix(Xi, Yi)) = b
                
            End If
        
        End If
    
    ElseIf XX <= PicInfo.bmWidth And YY <= PicInfo.bmHeight And XX >= 1 And YY >= 1 Then
    
        NewBits(Matrix(XX, YY) + 2) = r
        NewBits(Matrix(XX, YY) + 1) = g
        NewBits(Matrix(XX, YY)) = b
        
    End If
    
End Sub

' trace une ligne avec anticrnelage
Public Sub DrawLineAA( _
    ByVal x1 As Single, _
    ByVal y1 As Single, _
    ByVal x2 As Single, _
    ByVal y2 As Single, _
    ByVal rr As Byte, _
    ByVal gg As Byte, _
    ByVal bb As Byte)
    
    Dim M               As Single
    Dim b               As Single
    Dim XX              As Single
    Dim YY              As Single
    
    If x2 = x1 Then
        M = (y2 - y1) / 1
    Else
        M = (y2 - y1) / (x2 - x1)
    End If
    
    b = y1 - (M * x1)
    
    If Abs(M) <= 1 Then
        If x1 <= x2 Then
            For XX = x1 To x2
                YY = M * XX + b
                SetPixelAA XX, YY, rr, gg, bb
            Next XX
        Else
            For XX = x2 To x1
                YY = M * XX + b
                SetPixelAA XX, YY, rr, gg, bb
            Next XX
        End If
    Else
        If y1 <= y2 Then
            For YY = y1 To y2
                XX = (YY - b) / M
                SetPixelAA XX, YY, rr, gg, bb
            Next YY
        Else
            For YY = y2 To y1
                XX = (YY - b) / M
                SetPixelAA XX, YY, rr, gg, bb
            Next YY
        End If
    End If
    
End Sub

' trace un cercle avec anticrnelage
Public Sub DrawCircleAA( _
    ByVal X As Single, _
    ByVal Y As Single, _
    ByVal Rayon As Single, _
    ByVal rr As Byte, _
    ByVal gg As Byte, _
    ByVal bb As Byte)

    Dim XX      As Single
    Dim YY      As Single
    Dim r2      As Single
    Dim RMax    As Single

    If Rayon = 0 Then Exit Sub
    
    RMax = Rayon * 0.7071 ' ~= 1 / Sqr(2)
    r2 = Rayon * Rayon
    
    SetPixelAA X + Rayon, Y, rr, gg, bb
    SetPixelAA X, Y + Rayon, rr, gg, bb
    SetPixelAA X, Y - Rayon, rr, gg, bb
    SetPixelAA X - Rayon, Y, rr, gg, bb
    
    For XX = 1 To RMax
        
        YY = Sqr(r2 - XX * XX)
        
        SetPixelAA XX + X, YY + Y, rr, gg, bb
        SetPixelAA -XX + X, YY + Y, rr, gg, bb
        SetPixelAA XX + X, -YY + Y, rr, gg, bb
        SetPixelAA -XX + X, -YY + Y, rr, gg, bb

        SetPixelAA YY + X, XX + Y, rr, gg, bb
        SetPixelAA -YY + X, XX + Y, rr, gg, bb
        SetPixelAA YY + X, -XX + Y, rr, gg, bb
        SetPixelAA -YY + X, -XX + Y, rr, gg, bb
        
    Next XX
    
End Sub

' trace un arc de cercle avec anticrnelage
Public Sub DrawArcAA( _
    ByVal X As Single, _
    ByVal Y As Single, _
    ByVal Rayon As Single, _
    ByVal StartAngle As Single, _
    ByVal EndAngle As Single, _
    ByVal rr As Byte, _
    ByVal gg As Byte, _
    ByVal bb As Byte)

    Dim XX      As Single
    Dim YY      As Single
    Dim RMax    As Single
    Dim r2      As Single
    Dim a       As Single

    If Rayon = 0 Then Exit Sub
    
    RMax = Rayon * 0.7071 ' ~= 1 / Sqr(2)
    r2 = Rayon * Rayon
    
    If 0 >= StartAngle And 0 <= EndAngle Then SetPixelAA X + Rayon, Y, rr, gg, bb   ' 0        0
    If PIs2 >= StartAngle And PIs2 <= EndAngle Then SetPixelAA X, Y + Rayon, rr, gg, bb     ' 90       PI / 2
    If 3 * PIs2 >= StartAngle And 3 * PIs2 <= EndAngle Then SetPixelAA X, Y - Rayon, rr, gg, bb ' 270      3PI / 2
    If PI >= StartAngle And PI <= EndAngle Then SetPixelAA X - Rayon, Y, rr, gg, bb     ' 180      PI
    
    For XX = 1 To RMax
        
        YY = Sqr(r2 - XX * XX)
        a = (XX / RMax) * PIs4
        
        If a >= StartAngle And a <= EndAngle Then SetPixelAA XX + X, YY + Y, rr, gg, bb   ' 0    ->  45             0 -> PI/4
        a = a + PIs4
        If a >= StartAngle And a <= EndAngle Then SetPixelAA YY + X, XX + Y, rr, gg, bb       ' 45   ->  90             PI / 4
        a = a + PIs4
        If a >= StartAngle And a <= EndAngle Then SetPixelAA -YY + X, XX + Y, rr, gg, bb      ' 90   ->  135            PI / 2
        a = a + PIs4
        If a >= StartAngle And a <= EndAngle Then SetPixelAA -XX + X, YY + Y, rr, gg, bb      ' 135  ->  180            3PI / 4
        a = a + PIs4
        If a >= StartAngle And a <= EndAngle Then SetPixelAA -XX + X, -YY + Y, rr, gg, bb     ' 180  ->  225            PI
        a = a + PIs4
        If a >= StartAngle And a <= EndAngle Then SetPixelAA -YY + X, -XX + Y, rr, gg, bb     ' 225  ->  270            5PI / 4
        a = a + PIs4
        If a >= StartAngle And a <= EndAngle Then SetPixelAA YY + X, -XX + Y, rr, gg, bb      ' 270  ->  315            3PI / 2
        a = a + PIs4
        If a >= StartAngle And a <= EndAngle Then SetPixelAA XX + X, -YY + Y, rr, gg, bb      ' 315  ->  360 (=0)      7PI / 4
        
    Next XX
    
End Sub

' Trace une courbe de bzier avec anticrnelage
' ce n'est pas un algorithme super car il trace en fait plein de petites lignes
Public Sub DrawBezierAA( _
    ByVal StartX As Long, _
    ByVal StartY As Long, _
    ByVal StartAnchorX As Long, _
    ByVal StartAnchorY As Long, _
    ByVal EndX As Long, _
    ByVal EndY As Long, _
    ByVal EndAnchorX As Long, _
    ByVal EndAnchorY As Long, _
    ByVal rr As Byte, _
    ByVal gg As Byte, _
    ByVal bb As Byte, _
    ByVal Pas As Single)
    
    Dim ax              As Single
    Dim bx              As Single
    Dim cx              As Single
    Dim ay              As Single
    Dim by              As Single
    Dim cy              As Single
    
    Dim t               As Single
    
    Dim xt              As Single
    Dim yt              As Single
    
    Dim xt2             As Single
    Dim yt2             As Single
   
    cx = 3 * (StartAnchorX - StartX)
    bx = 3 * (EndX - StartAnchorX) - cx
    ax = EndAnchorX - StartX - cx - bx
    
    cy = 3 * (StartAnchorY - StartY)
    by = 3 * (EndY - StartAnchorY) - cy
    ay = EndAnchorY - StartY - cy - by

    xt2 = StartX
    yt2 = StartY

    For t = 0 To 1 Step Pas
            
        xt = ax * t ^ 3 + bx * t ^ 2 + cx * t + StartX
        yt = ay * t ^ 3 + by * t ^ 2 + cy * t + StartY
        
        DrawLineAA xt2, yt2, xt, yt, rr, gg, bb
        
        xt2 = xt
        yt2 = yt
        
    Next t
    
End Sub



