Attribute VB_Name = "mDialogHook"
' ==========================================================================================
' Code source par Nicolas Siwik aka Ennixo
' ==========================================================================================
' http://www.ennixo.com
' http://ennixo.free.fr/fils
' ennixo@free.fr
' ==========================================================================================

Private Type NMHDR
    hwndFrom As Long
    idfrom As Long
    code As Long
End Type

' Window Message
Private Const WM_DESTROY = &H2
Private Const WM_NOTIFY = &H4E
Private Const WM_NCDESTROY = &H82
Private Const WM_GETDLGCODE = &H87
Private Const WM_INITDIALOG = &H110
Private Const WM_COMMAND = &H111
Private Const WM_USER = &H400

' Common Dialog Notification
Private Const H_MAX As Long = &HFFFF + 1
Private Const CDN_FIRST = (H_MAX - 601)
Private Const CDN_LAST = (H_MAX - 699)
Private Const CDN_INITDONE = (CDN_FIRST - &H0)
Private Const CDN_SELCHANGE = (CDN_FIRST - &H1)
Private Const CDN_FOLDERCHANGE = (CDN_FIRST - &H2)
Private Const CDN_SHAREVIOLATION = (CDN_FIRST - &H3)
Private Const CDN_HELP = (CDN_FIRST - &H4)
Private Const CDN_FILEOK = (CDN_FIRST - &H5)
Private Const CDN_TYPECHANGE = (CDN_FIRST - &H6)
Private Const CDN_INCLUDEITEM = (CDN_FIRST - &H7)

' Common Dialog Message
Private Const CDM_FIRST = (WM_USER + 100)
Private Const CDM_GETFILEPATH = (CDM_FIRST + &H1)

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
    lpvDest As Any, lpvSource As Any, ByVal cbCopy As Long)

Private Declare Function GetParent Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function SendMessageString Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long

Private Const MAX_PATH = 260


Private Type RECT
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type

Private Declare Function SetParent Lib "user32" (ByVal hWndChild As Long, ByVal hWndNewParent As Long) As Long
Private Declare Function MoveWindow Lib "user32" (ByVal hWnd As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Private Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long
Private Const SM_CXDLGFRAME = 7
Private Const SM_CYDLGFRAME = 8
Private Const SM_CYCAPTION = 4

Private Declare Function FileExists Lib "shlwapi.dll" Alias "PathFileExistsA" (ByVal pszPath As String) As Long


Public Property Get GetCDlgFileName(ByVal hDlg As Long) As String

    Dim sBuf As String
    Dim iPos As Long
    Dim hWnd As Long

    hWnd = GetParent(hDlg)
    
    sBuf = String$(MAX_PATH, 0)
    
    SendMessageString hWnd, CDM_GETFILEPATH, 260, sBuf
    
    iPos = InStr(sBuf, vbNullChar)
    
    If iPos > 0 Then
    
        GetCDlgFileName = Left$(sBuf, iPos - 1)
       
    End If
   
End Property

Public Function DialogHookFunction(ByVal hDlg As Long, ByVal uiMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

    Dim tNMH            As NMHDR

    Select Case uiMsg
  
        Case WM_INITDIALOG 'Initialisation
            Debug.Print "WM_INITDIALOG"

            ' On a besoin de quelques variables
            Dim HookedHeight    As Long
            Dim tR              As RECT
            Dim tMother         As RECT
            Dim lYBorder        As Long
            Dim lXBorder        As Long
            Dim lYCaption       As Long
            Dim m_hWnd          As Long
            Dim m_X             As Long
            Dim m_Y             As Long
            Dim m_Width         As Long
            Dim m_Height        As Long

            ' on rcupre quelques informations
            HookedHeight = frmMain.fHook.Height
            m_hWnd = GetParent(hDlg)
            GetWindowRect m_hWnd, tR
            GetWindowRect frmMain.hWnd, tMother
            lYBorder = GetSystemMetrics(SM_CYDLGFRAME)
            lXBorder = GetSystemMetrics(SM_CXDLGFRAME)
            lYCaption = GetSystemMetrics(SM_CYCAPTION)
            
            ' Redimensionnement de la CD
            m_Width = tR.Right - tR.Left
            m_Height = (tR.Bottom - tR.Top) + HookedHeight
            MoveWindow m_hWnd, 0&, 0&, m_Width, m_Height, 0 ' on redessinera aprs
            
            ' ok, on peut la copier dedans now
            SetParent frmMain.fHook.hWnd, m_hWnd
            
            ' Placement de fHook dans la CD
            m_X = ((tR.Right - tR.Left) - frmMain.fHook.Width \ Screen.TwipsPerPixelX) \ 2 - lXBorder
            m_Y = (tR.Bottom - tR.Top) - lYCaption - lYBorder * 2 - 15
            m_Width = frmMain.fHook.Width \ Screen.TwipsPerPixelX
            m_Height = frmMain.fHook.Height \ Screen.TwipsPerPixelY
            MoveWindow frmMain.fHook.hWnd, m_X, m_Y, m_Width, m_Height, 1
            
            ' Ok, on l'affiche maintenant
            frmMain.fHook.Visible = True
            
            ' Ensuite on dplace au centre de la fentre
            GetWindowRect m_hWnd, tR
            m_X = tMother.Left + ((tMother.Right - tMother.Left) - (tR.Right - tR.Left)) \ 2
            m_Y = tMother.Top + ((tMother.Bottom - tMother.Top) - (tR.Bottom - tR.Top)) \ 2
            m_Width = tR.Right - tR.Left
            m_Height = (tR.Bottom - tR.Top)
            MoveWindow m_hWnd, m_X, m_Y, m_Width, m_Height, 1
            
        Case WM_NOTIFY ' Notification
        
            CopyMemory tNMH, ByVal lParam, Len(tNMH)
            
            Select Case tNMH.code
            
                Case CDN_SELCHANGE ' Changement de slection
                
                    Dim CurrentFile     As String
                
                    CurrentFile = GetCDlgFileName(hDlg)
                    
                    On Local Error GoTo Oups
                    
                    Select Case GetExt(CurrentFile)
                    
                        Case "bmp", "dib", "rle", "jpg", "jpe", "jpeg", "gif", "png", "wmf", "emf"
                            
                            Dim ratioX  As Single
                            Dim ratioY  As Single
                        
                            Debug.Print "CDN_SELCHANGE : " & CurrentFile
                            
                            frmMain.imgPreview = LoadPicture()
                            
                            frmMain.lblTaille = oKoMoGoTo(FileLen(CurrentFile))
                            frmMain.lblNom = getFichier(CurrentFile)
                            frmMain.picTemp.Picture = LoadPicture(CurrentFile)
                            
                            frmMain.lblDim = CStr(frmMain.picTemp.Width) & " * " & CStr(frmMain.picTemp.Height) & " pixels"
                            
                            ratioX = frmMain.picPreview.ScaleWidth / frmMain.picTemp.Width
                            ratioY = frmMain.picPreview.ScaleHeight / frmMain.picTemp.Height
                            
                            If ratioX < ratioY Then
                                ratioY = frmMain.picTemp.Height * ratioX
                                frmMain.imgPreview.Move 0, (frmMain.picPreview.ScaleHeight - ratioY) \ 2, frmMain.picPreview.ScaleWidth, ratioY
                            ElseIf ratioY < ratioX Then
                                ratioX = frmMain.picTemp.Width * ratioY
                                frmMain.imgPreview.Move (frmMain.picPreview.ScaleWidth - ratioX) \ 2, 0, ratioX, frmMain.picPreview.ScaleHeight
                            Else
                                frmMain.imgPreview.Move 0, 0, frmMain.picPreview.ScaleWidth, frmMain.picPreview.ScaleHeight
                            End If
                            
                            frmMain.imgPreview.Picture = frmMain.picTemp.Picture
                        
                        Case Else
Oups:
                            Debug.Print "CDN_SELCHANGE : (non lisible)"
                            frmMain.lblTaille = "0 octet"
                            frmMain.lblNom = "(aucun)"
                            frmMain.lblDim = "0 * 0 pixel"
                            frmMain.imgPreview = LoadPicture()
                            frmMain.picTemp = LoadPicture()
                            
                    End Select
                    
'                Case CDN_FOLDERCHANGE ' Changement de dossier (implique un selchange)
'                    Debug.Print "CDN_FOLDERCHANGE"
                    
'                Case CDN_FILEOK ' Cliqu sur Ok
'                    Debug.Print "CDN_FILEOK"
                    
'                Case CDN_HELP ' Demande de l'aide
'                    Debug.Print "CDN_HELP"
                    
                Case CDN_TYPECHANGE ' Changement de type de fichier
                    Debug.Print "CDN_TYPECHANGE"
                    
            End Select
        
        Case WM_COMMAND ' ?
            Debug.Print "WM_COMMAND"
            
        Case WM_DESTROY ' Destruction
            Debug.Print "WM_DESTROY"
            SetParent frmMain.fHook.hWnd, frmMain.hWnd
            frmMain.fHook.Visible = False
            
    End Select

    DialogHookFunction = uiMsg

End Function

Public Function GetAddress(ByVal Address As Long) As Long

  GetAddress = Address
  
End Function

