VERSION 5.00
Begin VB.UserControl ucDblSlider 
   BackColor       =   &H00D7D4C7&
   ClientHeight    =   555
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3840
   Picture         =   "ucDblSlider.ctx":0000
   ScaleHeight     =   555
   ScaleWidth      =   3840
   Begin VB.Image slHaut 
      Height          =   225
      Left            =   0
      Picture         =   "ucDblSlider.ctx":074E
      Top             =   60
      Width           =   225
   End
   Begin VB.Image Slider 
      Height          =   225
      Left            =   3570
      Picture         =   "ucDblSlider.ctx":09AF
      Top             =   315
      Width           =   225
   End
End
Attribute VB_Name = "ucDblSlider"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' ==========================================================================================
' Code source par Nicolas Siwik aka Ennixo
' ==========================================================================================
' http://www.ennixo.com
' http://ennixo.free.fr/fils
' ennixo@free.fr
' ==========================================================================================

Private m_X     As Long
Private m_Min   As Long
Private m_Max   As Long
Private m_Val1  As Long
Private m_Val2  As Long
Private m_Ovr   As OverrideSlider

Public Event Change()

Public Property Let Min(ByVal NewVal As Long)

    If NewVal < m_Max And NewVal <> m_Min Then
        m_Min = NewVal
        UpdateMyPos
    End If

End Property

Public Property Get Min() As Long

    Min = m_Min

End Property

Public Property Let Max(ByVal NewVal As Long)

    If NewVal > m_Min And NewVal <> m_Max Then
        m_Max = NewVal
        UpdateMyPos
    End If

End Property

Public Property Get Max() As Long

    Max = m_Max

End Property

Public Property Let Value1(ByVal NewVal As Long)

    If NewVal <= m_Max And NewVal >= m_Min And NewVal <> m_Val1 Then
        m_Val1 = NewVal
        UpdateMyPos
    End If

End Property

Public Property Get Value1() As Long

    Value1 = m_Val1

End Property

Public Property Let Value2(ByVal NewVal As Long)

    If NewVal <= m_Max And NewVal >= m_Min And NewVal <> m_Val2 Then
        m_Val2 = NewVal
        UpdateMyPos
    End If

End Property

Public Property Get Value2() As Long

    Value2 = m_Val2

End Property

Public Property Let Override(ByVal NewVal As OverrideSlider)

    m_Ovr = NewVal

End Property

Public Property Get Override() As OverrideSlider

    Override = m_Ovr

End Property

Private Sub UpdateMyPos()
    
    Dim Pos     As Long
    
    Pos = ((m_Val1 - m_Min) / (m_Max - m_Min)) * 3570
    Slider.Left = Pos
    
    Pos = ((m_Val2 - m_Min) / (m_Max - m_Min)) * 3570
    slHaut.Left = Pos
    
End Sub

Private Sub Slider_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

    m_X = X

End Sub

Private Sub Slider_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

    Dim Pos     As Long

    If Button = 1 Then
        Pos = Slider.Left + (X - m_X)
        If Pos < 0 Then Pos = 0
        If Pos > 3570 Then Pos = 3570
        Pos = (Pos / 3570) * (m_Max - m_Min) + m_Min
        Select Case m_Ovr
            Case OverrideSlider.NoOverride
                If Pos >= m_Val2 Then
                    Pos = m_Val2 - 1
                End If
            Case OverrideSlider.CanBeEqual
                If Pos > m_Val2 Then Pos = m_Val2
        End Select
        If m_Val1 <> Pos Then
            m_Val1 = Pos
            UpdateMyPos
            RaiseEvent Change
        End If
    End If

End Sub

Private Sub slHaut_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

    m_X = X

End Sub

Private Sub slHaut_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

    Dim Pos     As Long

    If Button = 1 Then
        Pos = slHaut.Left + (X - m_X)
        If Pos < 0 Then Pos = 0
        If Pos > 3570 Then Pos = 3570
        Pos = (Pos / 3570) * (m_Max - m_Min) + m_Min
        Select Case m_Ovr
            Case OverrideSlider.NoOverride
                If Pos <= m_Val1 Then Pos = m_Val1 + 1
            Case OverrideSlider.CanBeEqual
                If Pos < m_Val1 Then Pos = m_Val1
        End Select
        If m_Val2 <> Pos Then
            m_Val2 = Pos
            UpdateMyPos
            RaiseEvent Change
        End If
    End If

End Sub


Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    m_Min = PropBag.ReadProperty("Min", 0)
    m_Max = PropBag.ReadProperty("Max", 100)
    m_Val1 = PropBag.ReadProperty("Value1", 0)
    m_Val2 = PropBag.ReadProperty("Value2", 100)
    m_Ovr = PropBag.ReadProperty("Override", OverrideSlider.NoOverride)
    UpdateMyPos

End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    PropBag.WriteProperty "Min", m_Min, 0
    PropBag.WriteProperty "Max", m_Max, 100
    PropBag.WriteProperty "Value1", m_Val1, 0
    PropBag.WriteProperty "Value2", m_Val2, 100
    PropBag.WriteProperty "Override", m_Ovr, OverrideSlider.NoOverride

End Sub

Private Sub UserControl_Resize()

    UserControl.Width = 3840
    UserControl.Height = 555

End Sub
