VERSION 5.00
Begin VB.UserControl ucSlider 
   BackColor       =   &H00D7D4C7&
   ClientHeight    =   5145
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   7620
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Picture         =   "ucSlider.ctx":0000
   ScaleHeight     =   5145
   ScaleWidth      =   7620
   Begin VB.Image Slider 
      Height          =   225
      Left            =   120
      Picture         =   "ucSlider.ctx":06CE
      Top             =   150
      Width           =   225
   End
End
Attribute VB_Name = "ucSlider"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' ==========================================================================================
' Code source par Nicolas Siwik aka Ennixo
' ==========================================================================================
' http://www.ennixo.com
' http://ennixo.free.fr/fils
' ennixo@free.fr
' ==========================================================================================

Private m_X     As Long
Private m_Min   As Long
Private m_Max   As Long
Private m_Val   As Long

Public Event Change()

Public Property Let Min(ByVal NewVal As Long)

    If NewVal < m_Max And NewVal <> m_Min Then
        m_Min = NewVal
        UpdateMyPos
    End If

End Property

Public Property Get Min() As Long

    Min = m_Min

End Property

Public Property Let Max(ByVal NewVal As Long)

    If NewVal > m_Min And NewVal <> m_Max Then
        m_Max = NewVal
        UpdateMyPos
    End If

End Property

Public Property Get Max() As Long

    Max = m_Max

End Property

Public Property Let Value(ByVal NewVal As Long)

    If NewVal <= m_Max And NewVal >= m_Min And NewVal <> m_Val Then
        m_Val = NewVal
        UpdateMyPos
    End If

End Property

Public Property Get Value() As Long

    Value = m_Val

End Property

Private Sub UpdateMyPos()
    
    Dim Pos     As Long
    
    Pos = ((m_Val - m_Min) / (m_Max - m_Min)) * 3570
    
    Slider.Left = Pos

End Sub

Private Sub Slider_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

    m_X = X

End Sub

Private Sub Slider_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

    Dim Pos     As Long

    If Button = 1 Then
        Pos = Slider.Left + (X - m_X)
        If Pos < 0 Then Pos = 0
        If Pos > 3570 Then Pos = 3570
        If Slider.Left <> Pos Then Slider.Left = Pos
        Pos = (Pos / 3570) * (m_Max - m_Min) + m_Min
        If m_Val <> Pos Then
            m_Val = Pos
            RaiseEvent Change
        End If
    End If

End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    m_Min = PropBag.ReadProperty("Min", 0)
    m_Max = PropBag.ReadProperty("Max", 100)
    m_Val = PropBag.ReadProperty("Value", 0)
    UpdateMyPos

End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    PropBag.WriteProperty "Min", m_Min, 0
    PropBag.WriteProperty "Max", m_Max, 100
    PropBag.WriteProperty "Value", m_Val, 0

End Sub

Private Sub UserControl_Resize()

    UserControl.Width = 3840
    UserControl.Height = 390
    
End Sub
